function [CCMY,CCMP,CCMI,CCIY,CCIP,CCPY,GMY,GMP,GMI,GIY,GIP,GPY] = COH_MAT2(DFILE2,N,L)
% This function computes the coherence between money and macrovariables
% over the business cycle which is defined over a 6-32Q horizon. 

% Also, we calculate the gain over the business cycle too
%
%   \hat{kappa}_ij(w) = \frac{[\hat{c}_ij(w)]^2 + \hat[\hat{q}_{ij}(w)]^2}{\hat{f}^{ii}_{t|T}(w)*\hat{f}^{jj}_{t|T}(w)}
%

% Also churns out the unconditional variance of our variables which are the
% diagonal elements of the integral of the spectral densities

load(DFILE2)
NN = size(SD,3)-1; % Number of gibbs sampler outputs 5000 draws

% Get Spectral densities
clear QD VD UU S1 S2 S3 SS % Clear stuff you dont want from loading the output form TVP_MCMC

i = sqrt(-1);
T = size(SD,2);
omeg = linspace(0,pi,T/2)';
CCMY=zeros(NN,T);
CCMP=CCMY; CCMI=CCMY;
GMY=zeros(NN,T); GMP=GMY; GMI=GMY;

kk = 1;
%parfor kk=1:size(SD,2)
while kk<=size(SD,2)
    T-kk+1
    ll=1;
    while ll <=NN
%     for ll=1:size(SD,3)
        BETA = SD(:,kk,ll);
        bet = reshape(BETA',1+N*L,N)';
        bet = bet(:,2:end);
        for jl = 1:L
            B(:,:,jl) = bet(:,(jl-1)*N+1:(jl-1)*N+N); % 3rd dimension of B 
            % is the lagged coefficients in each equation e.g. B(:,:,2)
            % contains the coefficients of the second lag of endogenous
            % variables.
        end
        iA = inv(chofac(N,AA(:,kk,ll))); % Lower triangular A_{t}
        VAR = iA*diag(OM(kk,:,ll))*iA'; % This is the reduced form covariance matrix of the VAR
        SSS = zeros(N,N,length(omeg));
        C = zeros(N,N,length(omeg));
        for w = 1:length(omeg)
            GI = eye(N);
            for bl = 1:L
                %jl=1;
                %GI = GI - bet(:,(jl-1)*N+1:(jl-1)*N+N)*exp(-i*bl*omeg(w));
                GI = GI - B(:,:,jl)*exp(-i*bl*omeg(w));
                %jl=jl+1;
            end
             SSS(:,:,w) = (GI\VAR)*inv(GI');
        end
        
        % now get Coherence aggregate effect over business cycle
        cqmy=squeeze(sum(real(SSS(4,1,8:29))))^2+squeeze(sum(imag(SSS(4,1,8:29))))^2;
        cqmp=squeeze(sum(real(SSS(4,2,8:29))))^2+squeeze(sum(imag(SSS(4,2,8:29))))^2;
        cqmi=squeeze(sum(real(SSS(4,3,8:29))))^2+squeeze(sum(imag(SSS(4,3,8:29))))^2;
        cqiy=squeeze(sum(real(SSS(3,1,8:29))))^2+squeeze(sum(imag(SSS(3,1,8:29))))^2;
        cqip=squeeze(sum(real(SSS(3,2,8:29))))^2+squeeze(sum(imag(SSS(3,2,8:29))))^2;
        cqpy=squeeze(sum(real(SSS(2,1,8:29))))^2+squeeze(sum(imag(SSS(2,1,8:29))))^2;
        specy=sum(real(SSS(1,1,8:29))); specm=sum(real(SSS(4,4,8:29)));
        specp=sum(real(SSS(2,2,8:29))); speci=sum(real(SSS(3,3,8:29)));
        
        CMY=sqrt(cqmy/(specm*specy)); CMP=sqrt(cqmp/(specm*specp)); CMI=sqrt(cqmi/(specm*speci));
        CIY=sqrt(cqiy/(speci*specy)); CIP=sqrt(cqip/(speci*specp));
        CPY=sqrt(cqpy/(specp*specy));
        % Now get gain
        gmy=sqrt(cqmy)/specy; gmp=sqrt(cqmp)/specp; gmi=sqrt(cqmi)/speci;
        giy=sqrt(cqiy)/specy; gip=sqrt(cqip)/specp; gpy=sqrt(cqpy)/specy;
        CCMY(ll,kk)=CMY; CCMP(ll,kk)=CMP; CCMI(ll,kk)=CMI; 
        CCIY(ll,kk)=CIY; CCIP(ll,kk)=CIP; CCPY(ll,kk)=CPY;
        GMY(ll,kk)=gmy; GMP(ll,kk)=gmp; GMI(ll,kk)=gmi;
        GIY(ll,kk)=giy; GIP(ll,kk)=gip; GPY(ll,kk)=gpy;
        ll = ll + 1;
    end
    kk = kk + 1;
end
end