function IRFsRest = GetGIRFsZLB4(a0,sd,qd,qv,HOR,N,L,RL,YS)
MaxNum = 10000;

B=zeros(N,N*L+1,HOR+L+1);
qd_e = diag(qv)*rand(N*(1+N*L),HOR+L+1);
qd = log(qd);
for jj = 1:HOR+L+1
    qd(:,:,jj+1) = qd(:,:,jj) + qd_e(:,jj);
end
qd = exp(qd);
jj=2;
NumTry=0;
% Simulate B matrix
while jj<=HOR+L+1
    NumTry=NumTry+1;
    dd = sd(:,jj-1)+real(mysqrt_varm(diag(qd(:,jj))))*randn(N*(1+N*L),1);
    %dd = sd(:,:,jj-1) + real(mysqrt_varm(qd))*randn(N*(1+N*L),1); 
    b = [dd(1:1+N*L,1)'; dd((1+N*L)+1:2*(1+N*L),1)';...
        dd(2*(1+N*L)+1:3*(1+N*L),1)'; dd(3*(1+N*L)+1:4*(1+N*L),1)']; 
        if max(abs(varroots(L,N,b)))<1
                sd(:,:,jj)=dd;
                B(:,:,jj)=b;
                jj=jj+1;
                NumTry=0;
        else
            if NumTry>=MaxNum
                Y_Bench=-9999;
                Y_Silliq=-9999;
                return
            end
        end
end
B = B(:,2:size(B,2),2:size(B,3)); % Remove constant
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FOLLOW BAUMEISTER AND BENATI (2013) IJCB PAPER AS WELL AS CENTRAL BANKS %
% IMPOSE CONSTANT INTEREST RATE PROJECTION METHODOLOGY FOR LENGTH OF TIME %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% What we are doing is neutralising the response of the interest rate to an
% illiquidity shock by a path of negative monetary policy shocks for 8
% quarters.

SHOCKS = randn(N,HOR+L); %STRUC SHOCKS
Y_B = [YS zeros(N,HOR+(L-1)-L)];
Y_S = Y_B;
for tt = L+1:HOR+L
    shocks = SHOCKS(:,tt);
    bb = B(:,:,tt-L)*vec(myfliplr(Y_B(:,tt-L:tt-1)));
    if tt <= L+1+RL
        shocks(1) = (-bb(1)-a0(1,2:4)*shocks(2:4))/a0(1,1);
    end
    %Benchmark
    Y_B(:,tt) = bb + a0*shocks;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    shocks = SHOCKS(:,tt);
    if tt == L+1
        shocks(2) = 1+shocks(2);
    end
    bb = B(:,:,tt-L)*vec(myfliplr(Y_S(:,tt-L:tt-1)));
    if tt <= L+1+RL
        shocks(1) = (-bb(1)-a0(1,2:4)*shocks(2:4))/a0(1,1);
    end
    Y_S(:,tt) = bb+a0*shocks; % IRFs to illiquidity shock
end
IRFsRest = Y_S - Y_B;
IRFsRest = IRFsRest(:,L+1:end);