function [decomp]=get_fevdhorz(HOR,a0,B,YS,N,L,VAR)


Y_B = [YS zeros(N, HOR+(L-1)-L)]; % if YS(:,tt-L:tt-1) and tt=5 to start YS(:,1:4) if N= 3, L=4
    % then Y_B is 3x24 matrix with zeros in each row from column 5
    % "HOR+(L-1)-L" places a matrix of zeros with N rows through the
    % forecast horizon.
    Y_SUP = Y_B;
    Y_DEM = Y_B;
    Y_MOP = Y_B;
    Y_MOD = Y_B;
    SHOCKS = randn(N, HOR);
    % Calculate the impact of the shocks:
    Y_B(:,L+1) = a0*SHOCKS(:,1); % Y_B is Y_baseline where no shock occurs
    Y_SUP(:,L+1) = a0*[1+SHOCKS(1,1) SHOCKS(2:5,1)']'; % epsilon_1,i +1 is the first shock
    % a0 is 3x3 SHOCKS vector is 3x1 therefore the value in Y_SUP(:,L+1)
    % is the dot product of a0 and the shock vector where the first element
    % in SHOCKS vector is 1 + the random draw
    Y_DEM(:,L+1) = a0*[SHOCKS(1,1) 1+SHOCKS(2,1) SHOCKS(3:5,1)']';
    Y_MOP(:,L+1) = a0*[SHOCKS(1:2,1)' 1+SHOCKS(3,1) SHOCKS(4:5,1)']';
    Y_MOD(:,L+1) = a0*[SHOCKS(1:3,1)' 1+SHOCKS(4,1) SHOCKS(5,1)]';
    Y_MMM(:,L+1) = a0*[SHOCKS(1:4,1)' 1+SHOCKS(5,1)]';
    for tt = 2+L:HOR+L
        shocks = mysqrt_varm(VAR(:,:,tt-L))*SHOCKS(:,tt-L);
        % Take the eigenvalue eigenvector deocmposition of the variance
        % covariance matrix. VCV matrix is symmetric and positive definite
        % therefore  asquare root always exists. Taking the square root of
        % the eigenvalues always exists. eigenvalue eigenvector decomposit
        % -ion implies [Q,T] = eig(A), Q contains eigenvectors, and T contains the eigenvalues 
        % A=Q*T*Q' R=diag(sqrt(diag(T)); takes the square root of the eigenvalues
        % thus A^{0.5} = Q*R*Q';
        Y_B(:,tt) = B(:,:,tt-L)*[1; myvec(myfliplr(Y_B(:,tt-L:tt-1)))] + shocks;
        % if N=3, L=4 B(:,:,tt-L) is 3x13. let vec1 = 
        % [1; myvec(myfliplr(Y_B(:,tt-L:tt-1)))] denote the vector of lagged
        % dependent values at this point in time as well as the structural
        % impact matrix. myfliplr is essentially the same as fliplr and
        % flips the columns from left to right meaning that the structural
        % impact matrix are in rows 2:4 (essentially Y(t-1), row 1 is the 
        % constant. rows 5:7 Y(t-2), are observed Y values, 8:10 Y(t-3),
        % 11:13 Y(t-4). myvec does the same as A=A(:) stacking columns into
        % a vector. The dot product of B*vec1 is 3x1 adding shocks which is
        % also 3x1 results in Y_B(:,tt) being 3x1. This is the conditional
        % forecast at horizon tt under the scenario that no shock hits the
        % system.
        Y_SUP(:,tt) = B(:,:,tt-L)*[1; myvec(myfliplr(Y_SUP(:,tt-L:tt-1)))] + shocks;
        Y_DEM(:,tt) = B(:,:,tt-L)*[1; myvec(myfliplr(Y_DEM(:,tt-L:tt-1)))] + shocks;
        Y_MOP(:,tt) = B(:,:,tt-L)*[1; myvec(myfliplr(Y_MOP(:,tt-L:tt-1)))] + shocks;
        Y_MOD(:,tt) = B(:,:,tt-L)*[1; myvec(myfliplr(Y_MOD(:,tt-L:tt-1)))] + shocks;
        Y_MMM(:,tt) = B(:,:,tt-L)*[1; myvec(myfliplr(Y_MMM(:,tt-L:tt-1)))] + shocks;
        % The above are the conditional forecasts of variables in the VAR
        % when a shock hits the system.
    end
        Y_B = Y_B(:,L+1:end);
        Y_SUP = Y_SUP(:,L+1:end);
        Y_DEM = Y_DEM(:,L+1:end);
        Y_MOP = Y_MOP(:,L+1:end);
        Y_MOD = Y_MOD(:,L+1:end);
        Y_MMM = Y_MMM(:,L+1:end);
        
        % IRF is the differences between the conditional forecast of VAR
        % when a shock hits and the conditional forecast of when the shock
        % does not hit.
        
        irf1 = Y_SUP - Y_B; % shock 1
        irf2 = Y_DEM - Y_B; % shock 2
        irf3 = Y_MOP - Y_B; % shock 3
        irf4 = Y_MOD - Y_B; % shock 4
        irf5 = Y_MMM - Y_B; % shock 5

irf = zeros(N,N,HOR); % NOT ACCUMULATED 
        ir = zeros(N,N,HOR); % ACCUMULATED
        for xx = 1:HOR
            irf(:,:,xx) = [irf1(:,xx) irf2(:,xx) irf3(:,xx) irf4(:,xx) irf5(:,xx)];
        end
decomp = vardec(N,HOR,irf); % computes the forecast error variance decomposition
decomp=decomp(:,:,HOR);
end