function A = impact_ALT(O,B,pp,ll,horz,sim,YS)
% This finds the structural impact matrix A where some orthonormal matrix Q
% maximises the FEVD of variable ll to shock pp at horizon horz.

% Essentially combines Uhlig (2004) with Rubio Ramirez et al (2010). Here
% we 

N=size(O,1);
L=2;
crit=nan(sim,1);
Q=nan(N,N,sim);
HORZ=horz;
irfmat=zeros(N,HORZ,N); % shocks, by horizon, by variable
[P,D] = eig(O(:,:,1));
for gg=1:sim
    
Q(:,:,gg)=genQ(N);
A = P*D.^.5*Q(:,:,gg)';

FEV=get_fevdhorz(HORZ,A,B,YS,N,L,O);
crit(gg,1)=FEV(ll,pp); % contribution of shock pp to variable ll ar horizon horz   
end
[~,index]=max(crit);
Q=Q(:,:,index);
A = P*D.^.5*Q';
end
