function A = impact_ZR(O, N);
% This creates a structural impact matrix and then places a zero in row 3
% column 4 of a 4x4 covariance matrix
[P,D] = eig(O);

W = normrnd(0,1,N,N);
[Q, R] = qr(W);
for i = 1:N
    if R(i,i) < 0
        Q(:,i) = -Q(:,i);  % ensure positive
    end
end
A = P*D.^.5*Q';

% PUTS ZERO IN (3,4) position
%RM = [eye(2) zeros(2,2); zeros(2,2)...
%    [A(3,3)/sqrt(A(3,4)^2+A(3,3)^2) -A(3,4)/sqrt(A(3,4)^2+A(3,3)^2);...
%                    A(3,4)/sqrt(A(3,4)^2+A(3,3)^2) A(3,3)/sqrt(A(3,4)^2+A(3,3)^2)]];

% PUT ZERO IN (1,2) position
RM = [[A(1,1)/sqrt(A(1,2)^2+A(1,1)^2) -A(1,2)/sqrt(A(1,2)^2+A(1,1)^2);...
                    A(1,2)/sqrt(A(1,2)^2+A(1,1)^2) A(1,1)/sqrt(A(1,2)^2+A(1,1)^2)]...
                    zeros(2,2); zeros(2,2) eye(2)];
                
A = A*RM;


