% main file for productvity project EMW 2021
clear all; close all; clc;
% here we use TVP VAR where user specifies either Primiceri 2005 TVP VAR or
% the extension following Baumeister and Benati (2013).
G1=1; % G1==1 means Primiceri TVP VAR G1==0 means Baumeister and Benati TVP
NB=10000;% No. Simulations and Burn-in
D=10;    % save every 10th draw
NG=1000; % No. posterior draws
SC=1;    % Stability Constraint 1 means imposed.
ident=0; % 0 is SR, 1 is medium run restrictions with SR
L=2;     % lag length
TP=10;   % years used in training sample
Lambda='CogSa'; R=500; N=5; % R is number of simulations in MC integration,
% N is number of variables, Lambda is amount of time-variation
h=1;     % No horizon SR hold for. 1 corresponds to impact only.
FILTER=1;
PRELIM;

% get data
% Y is data matrix containing prod, unemp, vacancy, wages , inlfation
DATA=readtable('DATA');
Y=DATA{:,2:end};
%%
yearlab=(1951.00:0.25:2019.75)';

%figure(2)
%plot(yearlab, Y(:,2),'b-','LineWidth',2);
%shadenber()
%title('Unemployment Raw')
%axis tight

% Filter data or take log differences
if FILTER==0
Y=[log(Y(:,1)), Y(:,2:3), log(Y(:,4)), log(Y(:,5))];

for kk=1:size(Y,2)
   YY(:,kk)=100*(Y(5:end,kk)./Y(1:end-4,kk)); 
end
Y=YY; clear YY
yearlab=yearlab(5:end,:);
elseif  FILTER==1
% Filter data using Hamilton
[Y1, Y2, yearlab1, yearlab2]=filtereddata(Y,yearlab);
clear yearlab Y
RW=0;
% if RW==1 use random walk filtering. If RW==0 use regression filter.
if RW==1
    Y=Y1; yearlab=yearlab1;
    clear yearlab1 yearlab2 Y1 Y2
elseif RW==0
    Y=Y2; yearlab=yearlab2;
    clear yearlab1 yearlab2 Y1 Y2
end
end
y = [Y(:,1), Y(:,3), Y(:,2), Y(:,4), Y(:,5)];   % the data
% ORDER OF VARIABLES: Prod, Vacancy, Unemployment, Wages, inflation

% Plot the data
PLOT_ECONOMIC_DATA;

%% Now for estimation

if G1==1
a = TVP_BURN_MINN(DFILE1, y, NB, NG, L, TP, SC, Lambda);

c = TVP_MCMC_MINN(DFILE1, DFILE2, y, D, NG, L, TP, SC, Lambda); 
elseif G1==0
disp('error - Results for JMCB paper are Primiceri model')
%a = TVP_BURN_MINN_G2(DFILE1, y, NB, NG, L, TP, SC, Lambda);

%c = TVP_MCMC_MINN_G2(DFILE1, DFILE2, y, D, NG, L, TP, SC, Lambda); 
end
data=y;
if ident==0
[TIME, NN, TT] = TVP_IRF(DFILE2, L, N, TP, time, NG, data, DFILE3, h, SC, R, G1,ident);
elseif ident==1
    disp('error - Code will only provide main results. Contact authors for set of codes to get alternative identification')
%[TIME, NN, TT] = TVP_IRF(DFILE2, L, N, TP, time, NG, data, DFILE3, h, SC, R, G1,ident);
%[TIME, NN, TT] = TVP_IRF_Robust(DFILE2, L, N, TP, time, NG, data, DFILE3, h, SC, R, ident);
end

